#include "header.h"

void zoom_out (TM *tm) {
		if (tm->tfi->new_width >= 40 && tm->tfi->new_height >= 40) {
			if (tm->image != NULL) {
				gtk_widget_destroy(tm->image);
			}
			tm->pixbuf = gdk_pixbuf_new_from_file(tm->tfd->disp, NULL);

			tm->tfi->new_width = tm->tfi->new_width - tm->tfi->new_width / 5;
			tm->tfi->new_height = tm->tfi->new_height - tm->tfi->new_height / 5;

			tm->pixbuf = gdk_pixbuf_scale_simple(GDK_PIXBUF(tm->pixbuf), tm->tfi->new_width, tm->tfi->new_height, GDK_INTERP_BILINEAR);
			tm->image = gtk_image_new_from_pixbuf(tm->pixbuf);
			gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tm->scrolled), tm->image);

			gtk_widget_show(tm->image);
		}
}

void zoom_in (TM *tm) {
		if (tm->tfi->new_width < tm->tfi->width * 10 && tm->tfi->new_height < tm->tfi->height * 10) {
			if (tm->image != NULL) {
				gtk_widget_destroy(tm->image);
			}
			tm->pixbuf = gdk_pixbuf_new_from_file(tm->tfd->disp, NULL);

			tm->tfi->new_width = tm->tfi->new_width + tm->tfi->new_width / 5;
			tm->tfi->new_height = tm->tfi->new_height + tm->tfi->new_height / 5;

			tm->pixbuf = gdk_pixbuf_scale_simple(GDK_PIXBUF(tm->pixbuf), tm->tfi->new_width, tm->tfi->new_height, GDK_INTERP_BILINEAR);
			tm->image = gtk_image_new_from_pixbuf(tm->pixbuf);
			gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tm->scrolled), tm->image);

			gtk_widget_show(tm->image);
		}
}

void rotate_right (TM *tm) {
	if (tm->image != NULL) {
		gtk_widget_destroy(tm->image);
	}
	//	tm->pixbuf = gdk_pixbuf_new_from_file(tm->tfd->disp, NULL);
	tm->pixbuf = gdk_pixbuf_rotate_simple(tm->pixbuf, 90);
	tm->image = gtk_image_new_from_pixbuf(tm->pixbuf);
	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tm->scrolled), tm->image);
	/*
		tm->tfi->width = gdk_pixbuf_get_width(tm->pixbuf);
		tm->tfi->height = gdk_pixbuf_get_height(tm->pixbuf);
		tm->tfi->new_width = tm->tfi->width;
		tm->tfi->new_height = tm->tfi->height;
	*/
	gtk_widget_show(tm->image);
}

void rotate_left (TM *tm) {
	if (tm->image != NULL) {
		gtk_widget_destroy(tm->image);
	}
	//	tm->pixbuf = gdk_pixbuf_new_from_file(tm->tfd->disp, NULL);
	tm->pixbuf = gdk_pixbuf_rotate_simple(tm->pixbuf, 270);
	tm->image = gtk_image_new_from_pixbuf(tm->pixbuf);
	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tm->scrolled), tm->image);
	/*
		tm->tfi->width = gdk_pixbuf_get_width(tm->pixbuf);
		tm->tfi->height = gdk_pixbuf_get_height(tm->pixbuf);
		tm->tfi->new_width = tm->tfi->width;
		tm->tfi->new_height = tm->tfi->height;
	*/
	gtk_widget_show(tm->image);
}

void rotate_flip (TM *tm) {
	if (tm->image != NULL) {
		gtk_widget_destroy(tm->image);
	}
	//	tm->pixbuf = gdk_pixbuf_new_from_file(tm->tfd->disp, NULL);
	tm->pixbuf = gdk_pixbuf_rotate_simple(tm->pixbuf, 180);
	tm->image = gtk_image_new_from_pixbuf(tm->pixbuf);
	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tm->scrolled), tm->image);

	/*
		tm->tfi->width = gdk_pixbuf_get_width(tm->pixbuf);
		tm->tfi->height = gdk_pixbuf_get_height(tm->pixbuf);
		tm->tfi->new_width = tm->tfi->width;
		tm->tfi->new_height = tm->tfi->height;
	*/
	gtk_widget_show(tm->image);
}
